/* $Header: /usr2/brugere/jbln/uc133/src/RCS/hyper.h,v 1.1 1995/02/17 22:06:47 jbln Exp $ */

/*===[ Redefine at your own will ]==================================*/

   /* Key(s) to follow link */
#define HT_KEYFOLLOW1 terminal.enter
#define HT_KEYFOLLOW2 terminal.right

   /* - goto next link on scren */
#define HT_KEYNEXT terminal.down

   /* - goto previously link on screen */
#define HT_KEYPREV terminal.up

   /* - quit */
#define HT_KEYQUIT 'q'

   /* - goto next page */
#define HT_KEYDOWN terminal.pagedown

   /* - goto previous page */
#define HT_KEYUP terminal.pageup

   /* -	goto previous link */
#define HT_KEYBACK terminal.left


#define HT_INDENTSIZE 3		/* Number of chars to indent */
#define HT_TABSIZE 3		/* Number of chars between tabstops */

#define HT_NAMESIZE 50		/* Max. size of name field */
#define HT_LINKSIZE 50		/*           .. link       */

#define HT_LINESYMB '-'		/* Symbol to draw a horizontal line with */
#define HT_HEADLINESYMB '~'	/* Symbol to mark headlines with */
#define HT_BULLETSYMB '*'	/* Symbol to use as bullet */

/*===[ Do not touch this ]===============================================*/

#define HT_EXT 27
#define HT_END 0
#define HT_LINK 'l'
#define HT_ENTRY 'e'
#define HT_BULLET 'b'
#define HT_NEWLINE 'n'
#define HT_CENTER 'c'
#define HT_LINE 'z'
#define HT_HEADLINE 'h'
#define HT_PARAGRAPH 'p'
#define HT_FORMAT 'f'
#define HT_INDENT 'i'
#define HT_REM 'r'
#define HT_TAB 't'
#define HT_LESS '<'
#define HT_ENDBLOCK '/'

#define HT_END_CENTER 'C'
#define HT_END_HEADLINE 'H'
#define HT_END_FORMAT 'F'
#define HT_END_INDENT 'I'
#define HT_END_REM 'R'


typedef struct
{
   int x,y;
   int visible;
   char *name;
   char *link;
} HTLINK;

typedef struct
{
   char *p;
   int preformat;
   int lm, rm;
} PAGEINFO;

typedef struct
{
   int x,y;
   int l,c;
   FILE *ifile;
   char *fname;
   char *txt;
   char *cp, *ocp;
   int linknum;
   HTLINK *links;
   int ppnum;
   PAGEINFO *prevpage;
   int preformat;
   int lm, rm;
   int *prevlm;
   int plmnum;
   int was_pgup;
} HTEXT;


HTEXT *ht_new();

static int ht_find();
static int ht_load();
static int ht_remove();
static int ht_show();
static int ht_edit();
static int ht_cursor();
static int ht_parse();
static int ht_rmblank();
static int ht_readstr();
static int ht_push();
static int ht_pop();
static int ht_getch();
static int ht_clear();
static int ht_box();
static int ht_bold();
static int ht_bold_off();
static int ht_reverse();
static int ht_reverse_off();
